# Kapitanbooru Uploader

Kapitanbooru Uploader is a GUI application for uploading images to KapitanBooru. It provides features such as tag management, automatic tagging using wdtagger, and more.

## Features

- **Image Upload**: Easily upload images to KapitanBooru.
- **Tag Management**: Manage tags for images, including automatic tagging using wdtagger.
- **Cache Management**: Cache results from wdtagger to speed up processing.
- **Settings**: Configure application settings such as default tags, cache expiry, and more.

## Installation

1. Clone the repository:

    ```sh
    git clone https://git.mlesniak.pl/kapitan/kapitanbooru-uploader.git
    cd kapitanbooru-uploader
    ```

2. **Standard Installation (Supports most NVIDIA GPUs):**  

    ```bash  
    pip install .  
    ```  

3. **For RTX 50xx (Blackwell GPUs) with CUDA 12 Nightly Support:**  
    Requires the `cuda12-nightly` extra and PyTorch nightly binaries:  

    ```bash  
    pip install ".[cuda12-nightly]" --extra-index-url https://download.pytorch.org/whl/nightly/cu128 --pre  
    ```  

    Using `pipx` for isolated installation:  

    ```bash  
    pipx install "kapitanbooru-uploader[cuda12-nightly]" --pip-args "--extra-index-url https://download.pytorch.org/whl/nightly/cu128 --pre"  
    ```

4. Verify Python version:

    ```sh
    python --version
    # Should be >= 3.13
    ```

⚠️ **Notes:**  

- The `cuda12-nightly` extra depends on pre-release PyTorch packages from the specified index.  
- Private PyPI repository (for `wdtagger[cuda12-nightly]`) must already be configured in your environment (no URL needed here).

## Usage

1. Run the application:

    ```sh
    python -m kapitanbooru_uploader.main
    ```

2. Select the folder containing the images you want to upload.

3. Manage tags and upload images using the GUI.

## Configuration

Configuration settings can be found in the `settings.json` file located in the application data directory. You can modify settings such as username, password, base URL, default tags, and more.

## Development

### Debugging

You can use the provided VSCode launch configurations to debug the application. Open the `.vscode/launch.json` file and select the appropriate configuration.

## Contributing

Contributions are welcome! Please fork the repository and submit a pull request.

## License

This project is licensed under the MIT License. See the `LICENSE` file for details.

## Contact

For any questions or issues, please contact Michał Leśniak at [kapitan@mlesniak.pl](mailto:kapitan@mlesniak.pl).
